{
Author       : Alan Pozner
Date         : 7/07/90
Last revised : 7/07/90
Platforn     : 8xx86 CPU MSDOS operating system
Language     : Turbo Pascal 4.0
Description  : A program to display the calendar
}



program calendar;

uses dos,
     crt;

const
   normalyear = '312831303130313130313031';
   leapyear   = '312931303130313130313031';

   alphamonth : array[1..12] of string[9] = ('January','February','March',
                                           'April','May','June',
                                           'July','August','September',
                                           'October','November','December');
   NULL = #0;
   ESC = #27;
   UPKEY = #200;
   DOWNKEY = #208;
   LEFTKEY = #203;
   RIGHTKEY = #205;
   topleftcorner     = #218;
   toprightcorner    = #191;
   bottomleftcorner  = #192;
   bottomrightcorner = #217;
   horizontalline    = #196;
   verticalline      = #179;

var key       : char;
    counter   : byte;
    curyear,
    curmonth,
    curday,
    curdayofweek,
    year,
    month,
    day,
    dayofweek : word;
    oktoexit  : boolean;
    regs      : registers;

function returnstring(character : char ; number : integer) : string;
var
   tempstring : string;
   count      : byte;
begin
   tempstring := '';
   for count := 1 to number do
      tempstring := tempstring + character;
   returnstring := tempstring
end;

function intostr(i : longint; stringlength : byte; text : char) : string;
var
   s : string;

begin
   str(i, s);
   if length(s) < stringlength then
      s := returnstring(text,stringlength - length(s)) + s;
   intostr := s;
end;

function str2int(s : string) : integer;  (*convert a string to integer*)
var
   n    : integer;
   code : integer;

begin
   val(s,n,code);
   str2int := n;
end;


procedure drawscreen;
   procedure drawhline(startx,y,endx :byte);
   begin
      gotoxy(startx,y);
      for counter := startx to endx do
         write(horizontalline);
   end;

   function daysinmonth(year,month :word) : word;
   begin
      if year mod 4 = 0 then
         daysinmonth := str2int(copy(leapyear,(month-1)*2+1,2))
      else
         daysinmonth := str2int(copy(normalyear,(month-1)*2+1,2));

   end;

begin
   clrscr;
   writeln('        ',alphamonth[curmonth],', ',curyear);
   curday := 1;
   setdate(curyear,curmonth,curday);
   getdate(curyear,curmonth,curday,curdayofweek);
   gotoxy(curdayofweek*4+2,5);
   for counter := 1 to daysinmonth(curyear,curmonth) do
   begin
      write(intostr(counter,2,' '),'  ');
      if wherex > 27 then gotoxy(2,wherey+2);
   end;
   gotoxy(2,3);
   writeln('SUN MON TUE WED THU FRI SAT');
   drawhline(1,4,28);
   drawhline(1,6,28);
   drawhline(1,8,28);
   drawhline(1,10,28);
   drawhline(1,12,28);
   drawhline(1,14,28);
   gotoxy(1,16);
end;

function GetKey : char;
var
   C : Char;
begin
   C := ReadKey;
   repeat
      if C = NULL then
      begin
          C := ReadKey;
          if Ord(C) > 127 then
             C := NULL
          else
             GetKey := Chr(Ord(C) + 128);
       end
       else
          GetKey := C;
    until C <> NULL;
end;


begin
   getdate(year,month,day,dayofweek);
   curyear := year;
   curmonth := month;
   directvideo := false;
   oktoexit := false;
   drawscreen;
   repeat; { until oktoexit }
      key := getkey;
      case key of
         'e','E',ESC : oktoexit := true;
         downkey     : begin
                          curyear := curyear - 1;
                          drawscreen;
                       end;
         upkey       : begin
                          curyear := curyear + 1;
                          drawscreen;
                       end;
         rightkey    : begin
                          curmonth := curmonth + 1;
                          if curmonth > 12 then
                          begin
                             curmonth := 1;
                             curyear := curyear + 1;
                          end;
                          drawscreen;
                       end;
         leftkey     : begin
                          curmonth := curmonth - 1;
                          if curmonth < 1 then
                          begin
                             curmonth := 12;
                             curyear := curyear - 1;
                          end;
                          drawscreen;
                       end;

      end; { of case}
      setdate(year,month,day);
   until oktoexit;
   setdate(year,month,day);
end. {of program : calendar}